<template>
  <v-select
    v-model="region"
    :items="regions"
    color="accent"
    background-color="primary"
    item-color="accent"
    solo
    :placeholder="$_t('components.countries.filters.region_filter.placeholder')"
    :menu-props="{
      'offset-y': true,
      'nudge-top': -10,
      'content-class': `bg-primary ${
        $i18n.locale === 'fa' ? 'fa-font' : 'en-font'
      }`,
    }"
  ></v-select>
</template>

<script>
import { REGIONS } from "@/const/region.const";
import { mapActions } from "vuex";

export default {
  name: "RegionFilter",
  data() {
    return {
      region: null,
    };
  },
  computed: {
    regions() {
      return REGIONS;
    },
  },

  methods: {
    ...mapActions({
      fetchAllCountriesByRegion: "countries/fetchCountriesByRegion",

      /* loading handlers */
      startLoading: "loading/start",
      finishLoading: "loading/finish",
    }),

    filterByRegion(region) {
      this.startLoading();
      this.fetchAllCountriesByRegion({ region: region }).finally(() => {
        this.finishLoading();
      });
    },
  },

  watch: {
    region: function (region) {
      this.filterByRegion(region);
    },
  },
};
</script>

<style scoped lang="scss">
.theme--dark.v-list {
  background: #2b3945;
}
.v-list-item__content {
  color: white !important;
}
.theme--dark.v-list-item:hover:before {
  opacity: 0.14;
}
</style>
